' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
' AlCount.BAS
' By ...
'
' Notes:
' For the purposes of readability, this program uses ONE (1) as the first
' element of all arrays rather than ZERO (0).
' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
DIM Text AS STRING              ' text entered by user
DIM Alphabet(26) AS INTEGER     ' count of each letter in alphabet
DIM LetterCode AS INTEGER       ' value of single letter

PRINT "Input string: ";
INPUT Text

'
' reset array contents
'
FOR i = 1 TO 26 STEP 1
    Alphabet(i) = 0
NEXT i

'
' count the occurance of each letter
'
FOR i = 1 TO LEN(Text) STEP 1
   
    ' get the ASCII code value of the letter
    LetterCode = ASC(MID$(Text, i, 1))
   
    ' if it's >= 97 (lowercase), then subtract 96 for letter index
    IF LetterCode >= 97 THEN
        LetterCode = LetterCode - 96
    ' otherwise if it's >= 65 (uppercase), then subtract 64 for letter index
    ELSEIF LetterCode >= 65 THEN
        LetterCode = LetterCode - 64
    ' else this isn't a letter code, set to 27 (invalid index)
    ELSE
        LetterCode = 27
    END IF

    ' only update our array if the letter code is within range (0 to 25)
    IF LetterCode < 27 THEN
        Alphabet(LetterCode) = Alphabet(LetterCode) + 1
    END IF

NEXT i

'
' print count of each letter in two columns (for readability)
'
FOR i = 1 TO 13 STEP 1
    PRINT CHR$(i + 64); ":"; Alphabet(i), CHR$(i + 77); ":"; Alphabet(i + 12)
NEXT i

