//*[main.cpp]*******************************************************************
//
// Main program entry point.
// By Neil C. Obremski
//
//******************************************************************************
#include "xref.h"			// Xref Class Prototype
#include <iostream>			// cout

using namespace::std;

//_[main()]_____________________________________________________________________
//
// Program entry point.  Creates an instance of 'Xref', loads the words from
// input, and outputs the cross reference listing.
//
// Pre-Conditions: none.
// Post-Conditions: none.
//
int __cdecl main()
{
	Xref driver;

	cout << "Cross Reference Program" << endl;

	driver.LoadWords();

	driver.OutputCrossReference();

	cout << "End of program" << endl;

	return 0;
}