<?
require_once('news/format.php');
mt_srand ((double) microtime() * 1000000);

class NewsList
{
	var $addr;
	var $type;
	var $code;
	var $lmsg;
	var $trip;
	var $trtm;
	var $i;

	function NewsList()
	{
		$this->addr	= array();
		$this->type	= array();
		$this->code = array();
		$this->lmsg = array();
		$this->trip = array();
		$this->trtm = array();
		$this->i	= 0;
	}

	function Remove($remi)
	{
		$this->i--;
		for ($i = $remi; $i < $this->i; $i++)
		{
			$this->addr[$i] = $this->addr[$i+1];
			$this->type[$i] = $this->type[$i+1];
			$this->code[$i] = $this->code[$i+1];
			$this->lmsg[$i] = $this->lmsg[$i+1];
			$this->trip[$i] = $this->trip[$i+1];
			$this->trtm[$i] = $this->trtm[$i+1];
		}
	}

	function Add($new_addr, $new_type, $new_code, $new_lmsg, $new_trip, $new_trtm)
	{
		$this->addr[$this->i] = $new_addr;
		if ($new_type == '')
			$new_type = 'Text';
		$this->type[$this->i] = strtolower($new_type);
		$this->code[$this->i] = $new_code;
		$this->lmsg[$this->i] = $new_lmsg;
		$this->trip[$this->i] = $new_trip;
		$this->trtm[$this->i] = $new_trtm;
		return $this->i++;
	}

	function AddNew($new_addr, $new_type)
	{
		return $this->Add(
			$new_addr,
			$new_type,
			base_convert(mt_rand(0,2147483647), 10, 36),
			'',
			$GLOBALS['REMOTE_ADDR'],
			gmdate('F jS, Y @ g:i:sa') . ' (Universal Time)');
	}

	function Save($fn)
	{
		$filename = $GLOBALS['pbase'] . '/' . $fn;
		
		$fd = fopen($filename, 'wt');

		if ( $fd != 0 && flock($fd, LOCK_EX) && ftruncate( $fd, 0) )
		{
			fputs($fd, "<SUBSCRIBERS>\n");
			for ($i = 0; $i < $this->i; $i++)
			{
				$line = "\t<RECP EMAIL=\"{$this->addr[$i]}\" TYPE=\"{$this->type[$i]}\" CODE=\"{$this->code[$i]}\" LMSG=\"{$this->lmsg[$i]}\" TRIP=\"{$this->trip[$i]}\" TRTM=\"{$this->trtm[$i]}\" />";
				fputs($fd, $line . "\r\n");
			}
			fputs($fd, "</SUBSCRIBERS>");
		}
		else
		{
			echo('Failed to save list of recipients.  If you are attempting to subscribe or unlock your account, please send any information you can to the webmaster.');
			return false;
		}
		flock($fd, LOCK_UN);
		fclose($fd);
		return true;
	}

	function Find($addr)
	{
		for ($i = 0; $i < $this->i; $i++)
		{
			if ($this->addr[$i] == $addr)
				break;
		}
		return ($i < $this->i)?$i:-1;
	}

	function SendVfy($i)
	{
		if ($this->code[$i] == '')
			return false;

		$body = '';
		$headers = '';
		$trackip = $GLOBALS['REMOTE_ADDR'];
		$tracktm = gmdate('F jS, Y @ g:i:sa') . ' (Universal Time)';
		$url = 'http://www.neilstuff.com/index.php?uq=news&addr=' . rawurlencode($this->addr[$i]) . '&vfy=' . $this->code[$i];

		if ($this->type[$i] == 'html')
		{
			$body = '<HTML><BODY BGCOLOR=EEEEEE TEXT=000000 ALINK=RED LINK=BLUE VLINK=PURPLE>You have opted to be subscribed to the NeilStuff Newsletter (<A HREF="http://www.neilstuff.com/">NeilStuff.com</A>). This is a confirmation email to make sure that you are, in fact, the one who requested the subscription.  It is free and consists of an email newsletter sent, at most, once a week.  To confirm your subscription using the address "' . $this->addr[$i] . '", go to the following location with your web browser:<BR><CENTER><A HREF="' . $url . '">' . $url . '</A></CENTER><BR><BR>If you did not subscribe to the NeilStuff Newsletter, the following information may help you in tracking the culprit who subscribed your address:<BR><BR>i.p. = ' . $trackip . '<BR>time = ' . $tracktm . '</BODY></HTML>';
			$headers .= "Content-Type: text/html; charset=iso-8859-1\n";
		}
		else
		{
			$body = "You have opted to be subscribed to the NeilStuff Newsletter (http://www.neilstuff.com/).  This is a confirmation email to make sure that you are, in fact, the one who requested the subscription.  It is free and consists of an email newsletter sent, at most, once a week.  To confirm your subscription using the address \"{$this->addr[$i]}\", go to the following location with your web browser:\n\n{$url}\n\nIf you did not subscribe to the NeilStuff Newsletter, the following information may help you in tracking the culprit who subscribed your address:\n\ni.p. = $trackip\ntime = $tracktm";
		}

		$headers .= "From: NeilStuff News <news@neilstuff.com>\n";
		$headers .= "Return-Path: NeilStuff News <news@neilstuff.com>\n";
		$headers .= "X-Mailer: PHP\n";

		mail($this->addr[$i], 'Subscription Confirmation', $body, $headers);
		return true;
	}

	function SendNews($letter, $i)
	{
		$nlnum = substr($letter, 4, 3);

		if ($nlnum == $this->lmsg[$i] || $this->code[$i] != '')
			return false;

		$this->lmsg[$i] = $nlnum;
		$body = '';
		$headers = '';

		if ($this->type[$i] == 'html')
		{
			$body = '<HTML><BODY BGCOLOR=EEEEEE TEXT=000000 ALINK=RED LINK=BLUE VLINK=PURPLE>' . FormatXNL("news/{$letter}", $this->type[$i]) . '</BODY></HTML>';
			$headers .= "Content-Type: text/html; charset=iso-8859-1\n";
		}
		else
		{
			$body = FormatXNL("news/{$letter}", $this->type[$i]);
		}

		$headers .= "From: NeilStuff News <news@neilstuff.com>\n";
		$headers .= "Return-Path: NeilStuff News <news@neilstuff.com>\n";
		$headers .= "X-Mailer: PHP\n";

		mail($this->addr[$i], 'Newsletter #' . $nlnum, $body, $headers);
		return true;
	}
}

$gnl = null;

function startLNLElement($parser, $name, $attr)
{
	global $gnl;
	if ($name == 'RECP')
	{
		$gnl->Add(@$attr['EMAIL'], @$attr['TYPE'], @$attr['CODE'], @$attr['LMSG'], @$attr['TRIP'], @$attr['TRTM']);
	}
}

function endLNLElement($parser, $name)
{
}

function LoadNewsList($fn)
{
	global $gnl;
	$gnl = new NewsList();

	$xml_parser = xml_parser_create();
	xml_set_element_handler($xml_parser, "startLNLElement", "endLNLElement");
	if (!($fp = fopen($GLOBALS['pbase'] . '/' . $fn, "r"))) {
		die("could not open XML input");
	}
	flock($fp, LOCK_SH);

	while ($data = fread($fp, 4096)) {
		if (!xml_parse($xml_parser, $data, feof($fp))) {
			die(sprintf("XML error: %s at line %d",
					xml_error_string(xml_get_error_code($xml_parser)),
					xml_get_current_line_number($xml_parser)));
		}
	}

	flock($fp, LOCK_UN);
	fclose($fp);

	xml_parser_free($xml_parser);

	return $gnl;
}

?>