//------------------------------------------------------------------------------
// File: shape.h
// Desc: Declaration and Definitions for 'shape' class.
//------------------------------------------------------------------------------
#ifndef _SHAPE_H
#define _SHAPE_H

//_[headers]____________________________________________________________________
//
#include <iostream.h>		// i/o streaming (cout)

//_[global constants]___________________________________________________________
//
const float PI = 3.1459;	// PI for circle computations

//_[shape class]________________________________________________________________
//
// Base class for all shape classes.
//
class shape
{
public:

	//--------------------------------------------------------------------------
	// Name: print()
	// Desc:  Public function which displays information about the shape.  Since
	//		this is only a base class, there is no information to display.  All
	//		shapes should display their name (i.e. type of shape), any
	//		relevant calculations (area, perimeter, volume), and all member
	//		data (side lengths, height, etc.).
	//--------------------------------------------------------------------------
	virtual print()
	{
		cout << "Abstract shape!  Nothing to print!" << endl;
	}

}; // shape

#endif