' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
' ShBinary.BAS
' By ...
' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
DIM Number AS INTEGER           ' number inputted by user
DIM i AS INTEGER                ' generic index
DIM PowerVal AS INTEGER         ' power of 2 value, used for division in loop
DIM BinDigit(32) AS INTEGER     ' array to store binary rep of number
DIM BinLen AS INTEGER           ' length of binary number in DIGITS
DIM DigCount AS INTEGER         ' count to keep track of digits printed

'
' Begin program
'
PRINT "Enter a number: ";
INPUT Number

'
' Reset digits array (jic)
'
FOR i = 0 TO 32 STEP 1
    BinDigit(i) = 0
NEXT i

'
' Determine number as large as or larger than current number that is a
' power of two (2)
'
PowerVal = 1
WHILE Number > PowerVal
    PowerVal = PowerVal * 2
WEND
PowerVal = PowerVal * 2

'
' Loop through number
'
' This proces works by taking the power value (a value that is a power of
' two that is greater than the user's number at start) and dividing it by
' two which, in essence, decrements the count.  When the power value reaches
' one (1), it cannot be divided any longer and the loop ends.
'
' In each pass through the loop, the number is divided by the power value IF
' it is greater than it.  The result of this division indicates
'
BinLen = 0
DO
    PowerVal = PowerVal / 2

    ' If the current number's value is greater than or equal to the power
    ' value, set it to the remainder of the division between it and the
    ' power value.  This "decrements" the number.  If the power value is
    ' equal to the current number then the division will be even and the
    ' current number will be zero because that will be the remainder:
    ' for example, (2 MOD 2 = 0).
    ' This also sets the current binary digit to '1'.
    IF Number >= PowerVal THEN
        BinDigit(BinLen) = 1
        Number = Number MOD PowerVal
    END IF

    ' move to next digit
    BinLen = BinLen + 1
LOOP WHILE PowerVal > 1

'
' Output number
'
PRINT "Binary: ";

'
' determine if the binary digits length is evenly divisible by 4 ... if not
' the remainder (additional digits needed to be evenly divisible) will be
' stored into 'PowerVal'
'
PowerVal = BinLen MOD 4
DigCount = 0

'
' for loop to print preceding zeroes if length is not evenly divisible by 4
'
IF PowerVal <> 0 THEN
    PowerVal = 4 - PowerVal
    FOR i = 1 TO PowerVal STEP 1
        PRINT "0";
        DigCount = DigCount + 1
    NEXT i
END IF

'
' for loop to print number
'
FOR i = 0 TO BinLen - 1 STEP 1

    ' print strings to avoid the spaces from printing numbers directly
    ' AND because the division is ROUNDED so that the digit value might be
    ' 2 instead of 1 (for example, 3 / 2 = 2 because of rounding).
    IF BinDigit(i) > 0 THEN
        PRINT "1";
    ELSE
        PRINT "0";
    END IF

    ' increment digits printed
    DigCount = DigCount + 1
   
    ' print a space every four binary digits
    IF DigCount MOD 4 = 0 THEN
        PRINT " ";
    END IF

NEXT i

PRINT ' end of line

