/*****************************************************************************

	[item.cpp] Item abstract class empty implementation
	By Jeff Leung

*****************************************************************************/
#include "item.h"

//_[Item::~Item()]____________________________________________________________
//
// DESCRIPTION:
//  Destructor.
//
Item::~Item()
{
}

//_[Item::getIDProp()]________________________________________________________
//
// DESCRIPTION:
//  Retrieves the name of the property used as an identification for this type
//  of object.  For example with a book it would return "ISBN".
//
// PARAMETERS:
//  None.
//
// RETURN VALUE (string):
//  Returns a string containing the name of the id property.
//
string Item::getIDProp(void)
{
}

//_[Item::getName()]__________________________________________________________
//
// DESCRIPTION:
//  Retrieves the name of a particular property.
//
// PARAMETERS:
//  iProp ................. index of property to get name of
//
// RETURN VALUE (string):
//  Returns a string containing the name of the specified property.
//
string Item::getName(unsigned int)
{
}

//_[Item::getValue()]_________________________________________________________
//
// DESCRIPTION:
//  Retrieves the value of a particular property.
//
// PARAMETERS:
//  sProp ................. name of the property to get value of
//
// RETURN VALUE (string):
//  Returns a string containing the value of the specified property.
//
string Item::getValue(string &sProp)
{
}

//_[Item::getDesc()]__________________________________________________________
//
// DESCRIPTION:
//  Retrieves the description of a particular property.
//
// PARAMETERS:
//  sProp ................. name of the property to get description of
//
// RETURN VALUE (string):
//  Returns a string containing the description of the specified property.
//
string Item::getDesc(string &sProp)
{
}

//_[Item::setProp()]__________________________________________________________
//
// DESCRIPTION:
//  Sets the property specified by 'sName' to 'sValue'.
//
// PARAMETERS:
//  sName ................. name of property to set
//  sValue ................ value to set property to
//
// RETURN VALUE (Item::return_value):
//  Returns a code based on the result of the function.
//
Item::return_value Item::setProp(string &sName, string &sValue)
{
}

//_[Item::numProps()]_________________________________________________________
//
// DESCRIPTION:
//  Returns the number of public properties in this type of object.
//
// PARAMETERS:
//  None.
//
// RETURN VALUE (unsigned int):
//  See description.
//
unsigned int Item::numProps(void)
{
}