/*****************************************************************************

	[item.h] Item abstract class prototype
	By Jeff Leung

*****************************************************************************/
#ifndef ITEM_H
#define ITEM_H

#include <string>

using namespace std;

class Item
{
public:
	//_[function return values]_______________________________________________
	enum return_value
	{
		Okay,
		BadName,
		BadValue
	};

	virtual ~Item() = 0;

	virtual string getIDProp(void) = 0;
	virtual string getName(unsigned int) = 0;
	virtual string getValue(string &) = 0;
	virtual string getDesc(string &) = 0;
	virtual return_value setProp(string &, string &) = 0;
	virtual unsigned int numProps(void) = 0;

protected:
private:
};

#endif